summaryrefslogtreecommitdiffstats
path: root/target/image/x86/gen_image.sh
diff options
context:
space:
mode:
authornbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2006-10-08 15:48:56 +0000
committernbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2006-10-08 15:48:56 +0000
commit5cd5287c63bd0be72b4ae00fc1af508a2b42e541 (patch)
tree8bb05e3468ab2c57394f38af4dff7fbd16f82eca /target/image/x86/gen_image.sh
parenta963f60b9b11be446ebe3a77b528ee2513010597 (diff)
add grub based images for x86-2.6 - still a bit hackish, but works with ext2 and jffs2
git-svn-id: svn://svn.openwrt.org/openwrt/branches/buildroot-ng/openwrt@4962 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'target/image/x86/gen_image.sh')
-rwxr-xr-xtarget/image/x86/gen_image.sh60
1 files changed, 60 insertions, 0 deletions
diff --git a/target/image/x86/gen_image.sh b/target/image/x86/gen_image.sh
new file mode 100755
index 000000000..3edce1e40
--- /dev/null
+++ b/target/image/x86/gen_image.sh
@@ -0,0 +1,60 @@
+#!/bin/sh
+# Copyright (C) 2006 OpenWrt.org
+
+[ $# == 5 ] || {
+ echo "SYNTAX: $0 <file> <kernel size> <kernel directory> <rootfs size> <rootfs image>"
+ exit 1
+}
+
+file="$1"
+part1s="$2"
+part1d="$3"
+part2s="$4"
+part2f="$5"
+
+head=16
+sect=63
+cyl=$(( ($part1s + $part2s) * 1024 * 1024 / ($head * $sect * 512)))
+
+dd if=/dev/zero of="$file" bs=1M count=$(($part1s + $part2s)) 2>/dev/null || exit
+fdisk -u -C $cyl -H $head -S $sect "$file" > /dev/null 2>/dev/null <<EOF
+n
+p
+1
+
++${part1s}M
+n
+p
+2
+
++${part2s}M
+w
+q
+EOF
+
+block() {
+ echo -e 'p\nq' | fdisk -u -C $cyl -H $head -S $sect "$file" | awk -v file="$file$1" -v n="$(($2 + 2))" '
+$1 == file {
+ print $n * 512
+}'
+}
+
+start="$(block 1 0)"
+end="$(block 1 1)"
+blocks="$(( ($end - $start) / 1024 ))"
+
+genext2fs -d "$part1d" -b "$blocks" "$file.kernel"
+dd if="$file.kernel" of="$file" bs=512 seek="$(($start / 512))" conv=notrunc
+rm -f "$file.kernel"
+
+start="$(block 2 0)"
+dd if="$part2f" of="$file" bs=512 seek="$(($start / 512))" conv=notrunc
+
+which chpax >/dev/null && chpax -zp $(which grub)
+grub --device-map=/dev/null <<EOF
+device (hd0) $file
+geometry (hd0) $cyl $head $sect
+root (hd0,0)
+setup (hd0)
+EOF
+